#!pathtoperl



use strict;
use CGI::Carp qw(fatalsToBrowser);
use Mysql;
#use DBI; #perhaps a future version of ofcourse can use DBI, this implementation is too dependent upon Mysql to change without a major overhaul 


#the parameters to connect will only need to be changed right here
#for a different database
THEHOSTNAME     #the host the mysql server is running on
THEDATANAME  #the name of the database
THEUSERNAME      #the username to connect to the database
THEPASSNAME         #the password for connecting to the database




#returns the penalty time to inflict upon a booted user from the chatroom
#the maximum penalty time is 1 hour otherwise the system will break
sub bootexpiresafter{
    
    my $minutes = 5;
    if($minutes > 60){
	$minutes = 60;
    }
    return $minutes;
}

#returns the number of minutes of inactivity 
#before a user will time out of the chatroom
sub chatTimeout{
    my $minutes = 10;
    return $minutes;
}



#connect to the database
sub connecttodatabase{
    #possibly future versions of ofcourse can use the DBI module
   # my $sql_db = DBI->connect("dbi:mysql:$databasename:$host","$username","$password");
    my $sql_db = Mysql->connect($host,$databasename,$username,$password);    
    return $sql_db;
}


#return the hash table containing the course information
sub getCourseInfo{
    my $db = connecttodatabase();
    my $result = $db->query("select * from courseinformation");
    my %courseinfo = $result->FetchHash;
    return %courseinfo;
}


#print out specific lines of html
sub print_html{
    my $element=shift; #first parameter specifies what to print 
    my $db = connecttodatabase();
    if($element eq "headers"){ #print out HTML headers
	print "Content-type: text/html\n\n";
    }
    elsif($element eq "coursehead"){ #print out the opening html tags
	my %result = getCourseInfo();
	
	
	my $coursename = $result{coursename};
	
	print "<html><head><title>$coursename</title>";
	print_html("stylesheet");
	print "</head><body>";
    }
    elsif($element eq "courseheadnobody"){ #print out the opening html tags
	my %result = getCourseInfo();
	
	
	my $coursename = $result{coursename};
	
	print "<html><head><title>$coursename</title>";
	print_html("stylesheet");
	print "</head>";
    }
    elsif($element eq "javascriptvalidation"){ #include javascript file
	print "<script language=\"JavaScript\" src=\"validation.js\"></script>";
    }
    elsif($element eq "buttons"){
	my %courseinfo  = getCourseInfo();

	my $home=$courseinfo{ofcoursehome};
	
	
	print "<table cellpadding=0 cellspacing=1 align=center border=0 class=\"mainbuttons\">";
	print "<tr>";
	print "<td align=center valign=middle class=\"toplevelbutton\">";
	print "<a href=\"$home\">Main Page</a></td>";

	print "<td align=center valign=middle class=\"toplevelbutton\">";
	print "<a href=\"login.cgi\" target=\"theFrame\">Login</a></td>";
	
	
	my $buttons = $courseinfo{displaythesebuttons};
	
	
#	if($buttons =~/discussion/){
	print "<td align=center valign=middle class=\"toplevelbutton\">";
	print "<a href=\"discussion.cgi\" target=\"theFrame\" >Discussion<br>Board</a></td>\n";
#	}
#	if($buttons =~/communication/){
	print "<td align=center valign=middle class=\"toplevelbutton\">";
	print "<a href=\"communication.cgi\"target=\"theFrame\" >Communication</a></td>\n";
	    
#	}
#	if($buttons =~/fileexchange/){
	print "<td align=center valign=middle class=\"toplevelbutton\">";
	print "<a href=\"login.cgi?page=FileUploadTool/upload.php \"target=\"theFrame\" >\nFile Exchange</a><td>\n";
#	}

	print "<td align=center valign=middle class=\"toplevelbutton\">";
	print "<a href=\"login.cgi?page=classtools.cgi\"target=\"theFrame\" >\nClass Tools</a></td>\n";
	
    
	
	print "<td align=center valign=middle class=\"toplevelbutton\">";
	print "<a href=\"./calender/index.php\"target=\"theFrame\" >Calendar</A></TD>\n";
	
#	if($buttons =~/polling/){
	#    print "<td align=center valign=middle class=\"toplevelbutton\">";
	#    print "<a href=\"login.cgi?page=Poll/login3.cgi\"target=\"theFrame\" >\n<img src=\"buttons/$img\" border=0></a>\n";
#	}
#	if($buttons =~/fileexchange/){
#	    print "<td align=center valign=middle class=\"toplevelbutton\">";
#	    print "<a href=\"login.cgi?page=FileUploadTool/upload.php \"target=\"theFrame\" >\n<img src=\"buttons/$img\" border=0></a>\n";
#	}
#	if($buttons =~/calendar/){
#	    print "<td align=center valign=middle class=\"toplevelbutton\">";
#	    print "<a href=\"./calender/index.php\"target=\"theFrame\" >\n<img src=\"buttons/$img\" border=0></a>\n";
#	}


	
	
#	if($buttons =~/checkgrades/){
#	    $img = $colorchoice . "checkgrades.gif";
#	    print "<a href=\"login.cgi?page=checkgrades.cgi\"target=\"theFrame\" >\n<img src=\"buttons/$img\" border=0></a>\n";
	    
#	}
#	my $isadmin = isLoggedinAdmin();

#	if($isadmin){
#	    $img = $colorchoice . "admin.gif";
#	    print "<a href=\"login.cgi?page=admin.cgi\"target=\"theFrame\" >\n<img src=\"buttons/$img\" border=0></a>\n";
#	}
	
	
	print "</tr></table>";
    }
    elsif ($element eq "endhtml"){
	print "</body></html>";

    }
    elsif ($element eq "loginbuttons"){
	my %courseinfo  = getCourseInfo();
	my $colorchoice = $courseinfo{buttoncolorchoice};
	$colorchoice .= "-";
	print "<TABLE style =\" width:224;\"><TR>";
	my $img = $colorchoice . "register.gif";
	print "<td align=center valign=middle class=\"toplevelbutton\">";
	print "<a href=\"register.cgi\" target=\"theFrame\">Register</a>\n</td>";
	
	my $value = hasCookie(); 
	
	if($value != -1){ #if they have the cookie, they might want to logout
	    $img = $colorchoice . "logout.gif";
	    print "<td align=center valign=middle class=\"toplevelbutton\">";
	    print "<a href=\"logout.cgi\"target=\"theFrame\" >Logout</a>\n</td>";
	}
	print "</TR></TABLE>";
	
    }
    elsif ($element eq "stylesheet"){
	
	print "<link rel=\"stylesheet\" href=\"css.cgi\" type=\"text/css\">";
	
    }
    elsif ($element eq "substylesheet"){
	print "<link rel=\"stylesheet\" href=\"../css.cgi\" type=\"text/css\">";
    }
    elsif ($element eq "ofcourse"){
	print_html("headers");
	print_html("coursehead");
#	print_html("buttons");
	
    }
}





#Check to see if the user has our cookie
#takes no parameters
#return either userid or -1 if no cookie is found 
sub hasCookie{
    #if the user has the cookie this will be true
    if($ENV{HTTP_COOKIE} =~ /userinfo=(.*?)\;\sPHP/){ #get the checksum value of the 
     
	my $checksum = $1;                    #userid 

	my $db = connecttodatabase();         #get the database

	my $idres = $db->query("select userid from users where checksumid='$checksum'"); #get the userid 
	my $id=$idres->FetchRow; 

	return $id; #return the userid
    }
    elsif ($ENV{HTTP_COOKIE} =~ /userinfo=(.*)/){
	my $checksum = $1;                    #userid 

	my $db = connecttodatabase();         #get the database

	my $idres = $db->query("select userid from users where checksumid='$checksum'"); #get the userid 
	my $id=$idres->FetchRow; 

	return $id; #return the userid

    }
    #if the user doesnt have the cookie then return -1
    else {
	return -1;
    }
}


#function returns username for the specified userid
#takes in userid as a parameter and returns the username string
sub getUsername{

    my $id=shift; #get first parameter
    
    my $db = connecttodatabase(); #connect to the database
    
    my $usernameres = $db->query("select username from users where userid=$id"); 
    my $username=$usernameres->FetchRow;  #get the username from the database

    return $username; #return the username

}


#function returns the value of isapproved for a specified userid
#first parameter is a userid
#returns either 1 or 0
sub isApproved{
    my $id=shift; #get parameter
     
    my $db = connecttodatabase(); #connect to the database
    
    my $isappres = $db->query("select isapproved from users where userid=$id");
    my $isapproved=$isappres->FetchRow;  #get approved value for the database
    
    #if user is disapproved then $isapproved will be -1, reset this back to 0
    if ($isapproved == -1){
	$isapproved = 0;
    }

    return $isapproved; #return approved value

}


#function checks the value of isapproved for a specified userid
#and if the value is -1 returns 1 otherwise returns 0
#first parameter is a userid
#returns either 1 or 0
sub isDisapproved{
    my $id=shift; #get parameter
     
    my $db = connecttodatabase(); #connect to the database
    
    my $isappres = $db->query("select isapproved from users where userid=$id");
    my $isapproved=$isappres->FetchRow;  #get approved value for the database
    
    my $isdisapproved = 0; 
    
    #if isapproved is -1 than return 1, else return 0
    if ($isapproved == -1){
	$isdisapproved = 1;
    }
    
    return $isdisapproved; #return 1 or 0 

}



#function checks the value of isapproved for a specified userid
#and if the value is 0 returns 1 otherwise returns 0
#first parameter is a userid
#returns either 1 or 0
sub isPendingApproval{
    my $id=shift; #get parameter
     
    my $db = connecttodatabase(); #connect to the database
    
    my $isappres = $db->query("select isapproved from users where userid=$id");
    my $isapproved=$isappres->FetchRow;  #get approved value for the database
    
    my $pending = 0; 
    
    #if isapproved is 0 than return 1, else return 0
    if ($isapproved == 0){
	$pending = 1;
    }
    
    return $pending; #return 1 or 0 

}


#function checks to see if user is an admin
#first parameter is a userid
#returns 0 or 1
sub isAdmin{
    my $id=shift; #get the parameter
    
    my $db = connecttodatabase(); #connect to the database
   
    my $isadres = $db->query("select isadmin from users where userid=$id");
    my $isadmin=$isadres->FetchRow;  #get the isadmin value

    return $isadmin; #return the value

}



#determine if the user is logged in and has been approved
#takes no parameters
#returns 0 or 1
sub isLoggedin{
    my $id = hasCookie(); #get the id, or -1 if the user has no cookie
    my $isLoggedin = 0;   
    if( $id != -1){ #if we got an id check to see that its approved
	$isLoggedin = isApproved($id); #get the value
    }
    
    return $isLoggedin; #return 0 or 1
    
}


#determine if the user is logged in and is an admin
#takes no parameters
#returns 0 or 1
sub isLoggedinAdmin{
    my $id = hasCookie();  #get the id, or -1 if the user has no cookie
    my $isAdmin = 0;
    if( $id != -1){ #if we got an id check to see that its admin
	
	$isAdmin = isAdmin($id); 
	
    }
    
    return $isAdmin; #return 0 or 1
    
}


#this function takes in textual input and returns the same text
#with smiley images replacing their representative symbols
sub insertSmiles{
    my $data=shift;
    $data =~ s/O\:\-\)/<img src=\"smileys\/angel\.gif\">/xg; 
    $data =~ s/O\:\)/<img src=\"smileys\/angel\.gif\">/xg; 
    $data =~ s/o\:\-\)/<img src=\"smileys\/angel\.gif\">/xg; 
    $data =~ s/o\:\)/<img src=\"smileys\/angel\.gif\">/xg; 
    
    $data =~ s/\:\)/<img src=\"smileys\/happy\.gif\">/xg;
    $data =~ s/\:\-\)/<img src=\"smileys\/happy\.gif\">/xg;
    
    $data =~ s/\:\(/<img src=\"smileys\/sad\.gif\">/xg;
    $data =~ s/\:\-\(/<img src=\"smileys\/sad\.gif\">/xg;

    $data =~ s/\;\)/<img src=\"smileys\/wink\.gif\">/xg;
    $data =~ s/\;\-\)/<img src=\"smileys\/wink\.gif\">/xg;

    $data =~ s/\:\-P/<img src=\"smileys\/tongue\.gif\">/xg;   
    $data =~ s/\:P/<img src=\"smileys\/tongue\.gif\">/xg;   
    $data =~ s/\:\-p/<img src=\"smileys\/tongue\.gif\">/xg;   
    $data =~ s/\:p/<img src=\"smileys\/tongue\.gif\">/xg;   

    
    $data =~ s/\=\-O/<img src=\"smileys\/surprise\.gif\">/xg; 
    $data =~ s/\=O/<img src=\"smileys\/surprise\.gif\">/xg; 
    $data =~ s/\=\-o/<img src=\"smileys\/surprise\.gif\">/xg; 
    $data =~ s/\=o/<img src=\"smileys\/surprise\.gif\">/xg; 
    
    $data =~ s/\:\-\*/<img src=\"smileys\/kiss\.gif\">/xg; 
    $data =~ s/\:\*/<img src=\"smileys\/kiss\.gif\">/xg; 

    $data =~ s/&gt;\:o/<img src=\"smileys\/angry\.gif\">/xg; 

    $data =~ s/8\-\)/<img src=\"smileys\/cool\.gif\">/xg;
    $data =~ s/8\)/<img src=\"smileys\/cool\.gif\">/xg;
    
    $data =~ s/\:\'\(/<img src=\"smileys\/cry\.gif\">/xg;
    
    $data =~ s/\:\-\//<img src=\"smileys\/worry\.gif\">/xg;
    $data =~ s/[^p]\:\//<img src=\"smileys\/worry\.gif\">/xg;
    
    $data =~ s/\:\-X/<img src=\"smileys\/dead\.gif\">/xg; 
    $data =~ s/\:X/<img src=\"smileys\/dead\.gif\">/xg; 
    $data =~ s/\:\-x/<img src=\"smileys\/dead\.gif\">/xg; 
    $data =~ s/\:x/<img src=\"smileys\/dead\.gif\">/xg; 
    
    $data =~ s/\:\-D/<img src=\"smileys\/reallyhappy\.gif\">/xg; 
    $data =~ s/\:D/<img src=\"smileys\/reallyhappy\.gif\">/xg; 

    return $data;
}


#if a an HTML tag is found, ensure that its ok to be displayed
#if not then replace the < with &lt; and the > with &gt;
#takes in a string and returns a fixed string
sub cleanPost{
    my $data = shift;
    my $open = "&lt;";
    my $close = "&gt;";

    #allowed tags are: <a href=" "> </a>, <b> </b>,<i> </i>,<s> </s>,<u> </u>
    #<font color=> </font> (note: size not allowed), <br>, <p> </p>,
    #<blockquote> </blockquote>
    
    
    $data =~ s/</$open/ig;
    $data =~ s/>/$close/ig;
    $data =~ s/\n/<br>/g;
    
    #allow href
    $data =~ s/$open\s*a\s*href\s*=\s*[\'\"]([^\'\"]+)[\'\"]\s*$close(.+?)$open\s*\/\s*a\s*$close/<a href=\"$1\" target=\"_blank\">$2<\/a>/gis;
    
    #allow b
    $data =~ s/$open\s*b\s*$close(.+?)$open\s*\/\s*b\s*$close/<b>$1<\/b>/gis;

    #allow i
    $data =~ s/$open\s*i\s*$close(.+?)$open\s*\/\s*i\s*$close/<i>$1<\/i>/gis;

    #allow s
    $data =~ s/$open\s*s\s*$close(.+?)$open\s*\/\s*s\s*$close/<s>$1<\/s>/gis;

    #allow u
    $data =~ s/$open\s*u\s*$close(.+?)$open\s*\/\s*u\s*$close/<u>$1<\/u>/gis;
    
    #allow br
    $data =~ s/$open\s*br\s*$close/<br>/gis;
    
    #allow p
    $data =~ s/$open\s*p\s*$close(.+?)$open\s*\/\s*p\s*$close/<p>$1<\/p>/gis;

    #allow blockquote
    $data =~ s/$open\s*blockquote\s*$close(.+?)$open\s*\/\s*blockquote\s*$close/<blockquote>$1<\/blockquote>/gis;

    #allow font color
    $data =~ s/$open\s*font\s*color\s*=\s*[\'\"]([^\'\"]+?)[\'\"]\s*$close(.*?)$open\s*\/\s*font\s*$close/<font color=\"$1\">$2<\/font>/gis;
    
   
    
    
    $data = filterWords($data); #filter blocked words
    return $data;
}




#if a an HTML tag is found, ensure that its ok to be displayed
#if not then replace the < with &lt; and the > with &gt;
#takes in a string and returns cleaned string
sub fullCleanPost{
    my $data = shift;
    my $open = "&lt;";
    my $close = "&gt;";

    #allowed tags are: <a href=" "> </a>, <b> </b>,<i> </i>,<s> </s>,<u> </u>
    #<font color=> </font> (note: size not allowed)
    
#dont forget to check on the endline...

    $data =~ s/</&lt\;/ig;
    $data =~ s/>/&gt\;/ig;
    

    #remove href html completely
    
    $data =~ s/&lt\;\s*a\s*href\s*=\s*[\'\"]([^\'\"]+)[\'\"]\s*&gt\;(.+?)&lt\;\s*\/a&gt\;/$2/gi;
    
    #remove b
    $data =~ s/$open\s*b\s*$close(.*?)$open\s*\/\s*b\s*$close/$1/gis;

    #allow i
    $data =~ s/$open\s*i\s*$close(.*?)$open\s*\/\s*i\s*$close/<i>$1<\/i>/gis;

    #allow s
    $data =~ s/$open\s*s\s*$close(.*?)$open\s*\/\s*s\s*$close/<s>$1<\/s>/gis;

    #allow u
    $data =~ s/$open\s*u\s*$close(.*?)$open\s*\/\s*u\s*$close/<u>$1<\/u>/gis;
    
    #remove br
    $data =~ s/$open\s*br\s*$close//gis;
    
    #remove p
    $data =~ s/$open\s*p\s*$close(.*?)$open\s*\/\s*p\s*$close/$1/gis;

    #remove blockquote
    $data =~ s/$open\s*blockquote\s*$close(.*?)$open\s*\/\s*blockquote\s*$close/$1/gis;
    

    #allow font color
    $data =~ s/$open\s*font\s*color\s*=\s*[\'\"]([^\'\"]+)[\'\"]\s*$close(.*?)$open\s*\/\s*font\s*$close/<font color=\"$1\">$2<\/font>/gis;

    
    $data = filterWords($data);
    return $data;
    
    

}


#In order for an insert into the database \ ' and " must be escaped.
#function takes in a string and escapes \ ' " then returns the repaired 
#string
sub cleanPunctuation{
    my $body =shift;
    $body =~ s/\\/\\\\/g;
    $body =~ s/\'/\\\'/g;
    $body =~ s/\"/\\\"/g;
    return $body;

}



#filter out offensive content
#function takes in a string and returns the cleaned string
#the file disallowedwords contains all strings which 
#should be filtered out. This file can also contain regularons.
sub filterWords{
    my $data = shift;
    my $replace = "**removed**"; #this is what the word will be replaced with
    open(INFILE,"disallowedwords"); #open the disallowed words file
    
    
    my @disallowedwords = <INFILE>; #read in all the words

    
    
    foreach my $word(@disallowedwords){ #go through each word and if it is found replace it with $replace
	chop($word);
	$data =~ s/(\W)$word(\W)/$1$replace$2/gis;
	$data =~ s/^$word$/$replace/gis;
	$data =~ s/^$word(\W)/$replace$1/gis;
	$data =~ s/(\W)$word$/$1$replace/gis;
	
	
    }
    
    return $data;


}

##Takes in an SQL datetime and converts to normal date/time format##
##e.g. 2003-04-04 00:00:00 translates to April 4, 2003, 12:00AM##
sub parse_time{
  my $date_time = $_[0];
  $date_time =~ /(\d\d\d\d)-(\d\d)-(\d\d)\s(\d\d):(\d\d)/;
  my $month = convert_month($2);

  my $first_seg = "$2/$3/$1 - ";
  $first_seg = "$month $3, $1 - ";
  my $hour = $4;
  my $min = $5;
  my $meridian = "AM";
  
  if($hour >= 13){
    $hour= $hour - 12;
    $meridian = "PM";
  }
  elsif($hour == 12){
    $meridian = "PM";
    
  }
  elsif($hour == 0){
    $hour = 12;
  }
  
  return "$first_seg$hour:$min $meridian";
}



#takes in the entry time and the current time for the chatroom and
#returns the difference
sub timeInChat{
    my $entrytime = shift;  #first parameter, a datetime
    my $now = shift;        #second parameter, a datetime
    

    #parse eacht time down to days/minutes/seconds
    $entrytime =~ /(\d\d\d\d)-(\d\d)-(\d\d)\s(\d\d):(\d\d)/;
    my $sday = $3;
    my $shour = $4;
    my $smin = $5;
    
    $now =~ /(\d\d\d\d)-(\d\d)-(\d\d)\s(\d\d):(\d\d)/;
    my $curday = $3;
    my $curhour = $4;
    my $curmin = $5;
    

    my $daydiff;
    if($curday > $sday){ #if a day changed
	
	$daydiff=$curday-$sday;
	$daydiff *= 24; #multiply days by 24 hours 
	$curhour += $daydiff;  #add the days
    }
    elsif ($curday < $sday){ #rolled over a month..
	$daydiff=30;  #this is approximate...at this point their is no way someone is still lgged in...
	$daydiff *= 24;
	$curhour += $daydiff;
    }
    
    
    if ($shour > 0){
	$shour *= 60;
	$smin += $shour;
    }
    
    if($curhour > 0){
	$curhour *= 60;
	$curmin += $curhour;
    }
    
    my $diff = $curmin - $smin;
    return $diff;
}


#takes in the last time the user was active and the current time
#returns whether or not they should be booted
sub bootChatUser{
    my $entrytime = shift;  #first parameter, a datetime
    my $now = shift;        #second parameter, a datetime
    

    #parse eacht time down to days/minutes/seconds
    $entrytime =~ /(\d\d\d\d)-(\d\d)-(\d\d)\s(\d\d):(\d\d)/;
    my $sday = $3;
    my $shour = $4;
    my $smin = $5;
    
    $now =~ /(\d\d\d\d)-(\d\d)-(\d\d)\s(\d\d):(\d\d)/;
    my $curday = $3;
    my $curhour = $4;
    my $curmin = $5;
    

    my $daydiff;
    if($curday > $sday){ #if a day changed
	
	$daydiff=$curday-$sday;
	$daydiff *= 24; #multiply days by 24 hours 
	$curhour += $daydiff;  #add the days
    }
    elsif ($curday < $sday){ #rolled over a month..
	$daydiff=30;  #this is approximate...at this point their is no way someone is still lgged in...
	$daydiff *= 24;
	$curhour += $daydiff;
    }
    
    
    if ($shour > 0){
	$shour *= 60;
	$smin += $shour;
    }
    
    if($curhour > 0){
	$curhour *= 60;
	$curmin += $curhour;
    }
    
    my $diff = $curmin - $smin;
        
    my $timeoutval =  chatTimeout();
    
    if($diff > $timeoutval){
	return 1;
    }
    else{
	return 0;
    }
    

}




##Converts numerical months to textual##
sub convert_month{
  if($_[0] == 1){ return "January";}
  if($_[0] == 2){ return "February";}
  if($_[0] == 3){ return "March";}
  if($_[0] == 4){ return "April";}
  if($_[0] == 5){ return "May";}
  if($_[0] == 6){ return "June";}
  if($_[0] == 7){ return "July";}
  if($_[0] == 8){ return "August";}
  if($_[0] == 9){ return "September";}
  if($_[0] == 10){ return "October";}
  if($_[0] == 11){ return "November";}
  if($_[0] == 12){ return "December";}

}

##Converts textual months to numerical##
sub convert_back_month{
  if($_[0] eq "January"){return "1";}
  if($_[0] eq "February"){return "2";}
  if($_[0] eq "March"){return "3";}
  if($_[0] eq "April"){return "4";}
  if($_[0] eq "May"){return "5";}
  if($_[0] eq "June"){return "6";}
  if($_[0] eq "July"){return "7";}
  if($_[0] eq "August"){return "8";}
  if($_[0] eq "September"){return "9";}
  if($_[0] eq "October"){return "10";}
  if($_[0] eq "November"){return "11";}
  if($_[0] eq "December"){return "12";}
}




#determines if a user is logged in to the chatroom
#returns 1 if user is logged in and 0 if they are not
sub chatLoggedIn{
    my $user=hasCookie();
    my $db=connecttodatabase();
    
    my $result=$db->query("select * from chatusers where userid=$user");
    if(my $minutes = $result->FetchRow){
	return 1;
    }
    else {
	return 0;
    }
}


#Determines if a user has been booted from the chatroom and if they have
#calculates if they have served the penalty time or not.
#returns 1 if they were booted and havent served the penalty, 
#returns 0 if they are allowed back in the chat
sub chatBooted{
    my $user=hasCookie();
    my $db=connecttodatabase();

    my $bootexpires = bootexpiresafter(); #time till user can re-enter chat
    my $result=$db->query("select *,now() as now from bootedfromchat where userid=$user");

    #if the user was booted determine if they can go back in yet
    if(my %isbooted = $result->FetchHash){ 
	my $time = $isbooted{now};
	my $bootedsince = $isbooted{timebooted};
	
	#parse time values
	$time =~ /(\d\d\d\d)-(\d\d)-(\d\d)\s(\d\d):(\d\d)/;
	my $cyear = $1;
	my $cmonth = $2;
	my $cday = $3;
	my $chour = $4;
	my $cmin = $5;
	$bootedsince =~ /(\d\d\d\d)-(\d\d)-(\d\d)\s(\d\d):(\d\d)/;
	my $byear = $1;
	my $bmonth = $2;
	my $bday = $3;
	my $bhour = $4;
	my $bmin = $5;
	my $returnval;

	
	#theoretically this accounts for even a year change, but it is untested
	#and rather difficult to test until december 31st.
	if($cyear != $byear){ #if the year is different
	    if($cmonth != 1){ #if its not january
		$returnval =  0; #then they served their sentence
	    }
	    elsif ($cday != 1){ #else if its not jan 1st 
		$returnval = 0; #they served their sentence
	    }
	    elsif ($chour != 0){ #else if its not between midnight and one
		$returnval = 0;   #they served their sentence
	    }
	    elsif ((60-$bmin + $cmin) >= $bootexpires){ #if it is actually new
		$returnval = 0; #years determine if they have served sentence
	    }
	    else {
		return 1; #if its new years and they were booted after 11.01 pm  dec 31 they have not yet served their sentence
	    }
	}
	elsif($cmonth != $bmonth){ #else if its a month roll
	    if ($cday != 1){ #if the day is not the first
		$returnval = 0; #they served
	    }
	    elsif ($chour != 0){ #else if its after 1 am
		$returnval = 0; #they served
	    }
	    elsif ((60-$bmin + $cmin) >= $bootexpires){
		$returnval = 0; #calculate if its been $bootexpires time
	    }
	    else {
		return 1;
	    }
	    
	}
	elsif($cday != $bday){ #same as above
	    if ($chour != 0){
		$returnval = 0;
	    }
	    elsif ((60-$bmin + $cmin) >= $bootexpires){
		$returnval = 0;
	    }
	    else {
		return 1;
	    }    
	}
	elsif($chour != $bhour){
	    if ((60-$bmin + $cmin) >= $bootexpires){
		$returnval = 0;
	    }
	    else {
		return 1;
	    }    
	}
	else {
	    if(($cmin-$bmin) >= $bootexpires){
		$returnval = 0;
	    }
	    else {
		return 1;
	    }
	}
	
	if($returnval == 0){ #if they are allowed to enter now
	    $db->query("delete from bootedfromchat where userid=$user");
	    return 0;
	}
    }
    else {
	return 0;
    }
}



1;
