-- Table structure for table `D_B_Topics` --

CREATE TABLE D_B_Posts (
  postid int(11) NOT NULL auto_increment,
  threadid int(11) NOT NULL default '0',
  topicid int(11) NOT NULL default '0',
  userid int(11) NOT NULL default '0',
  timeofpost datetime NOT NULL default '0000-00-00 00:00:00',
  posttext text,
  isreplyto int(11) NOT NULL default '0',
  isanonymous int(11) NOT NULL default '0',
  name text NOT NULL,
  threadname text,
  PRIMARY KEY  (postid)
) TYPE=MyISAM;

-- Table structure for table `D_B_Topics` --

CREATE TABLE D_B_Topics (
  topicid int(11) NOT NULL auto_increment,
  topicname char(80) NOT NULL default '',
  isarchived int(11) default '0',
  PRIMARY KEY  (topicid)
) TYPE=MyISAM;

-- Table structure for table `D_B_Views` --

CREATE TABLE D_B_Views (
  viewid int(11) NOT NULL auto_increment,
  userid int(11) NOT NULL default '0',
  topicid int(11) NOT NULL default '0',
  threadid int(11) NOT NULL default '0',
  totalviews int(11) default '1',
  postid int(11) NOT NULL default '0',
  timeofview datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (viewid)
) TYPE=MyISAM;

-- Table structure for table `FileManagementHistory` --

CREATE TABLE FileManagementHistory (
  UserName varchar(100) NOT NULL default '',
  Activity varchar(200) default NULL,
  FileName varchar(100) default NULL,
  At datetime default '0000-00-00 00:00:00'
) TYPE=MyISAM;

-- Table structure for table `SharedFiles` --

CREATE TABLE SharedFiles (
  ShareTo varchar(100) NOT NULL default '',
  FileID int(11) NOT NULL default '0'
) TYPE=MyISAM;

-- Table structure for table `Turnin` --

CREATE TABLE Turnin (
  TurinA int(11) default NULL,
  Assigment varchar(100) NOT NULL default ''
) TYPE=MyISAM;

-- Table structure for table `UploadedFiles` --

CREATE TABLE UploadedFiles (
  FileID int(11) NOT NULL auto_increment,
  Owner varchar(100) NOT NULL default '',
  FileName text NOT NULL,
  Comment text,
  File mediumblob NOT NULL,
  Size int(11) NOT NULL default '0',
  Path varchar(100) default NULL,
  PRIMARY KEY  (FileID)
) TYPE=MyISAM;

-- Table structure for table `bootedfromchat` --

CREATE TABLE bootedfromchat (
  userid int(11) NOT NULL default '0',
  timebooted datetime default NULL
) TYPE=MyISAM;

-- Table structure for table `buttons` --

CREATE TABLE buttons (
  buttonid int(11) NOT NULL auto_increment,
  name text,
  description text,
  PRIMARY KEY  (buttonid)
) TYPE=MyISAM;

-- Table structure for table `calendarmssgs` --

CREATE TABLE calendarmssgs (
  id mediumint(5) unsigned NOT NULL auto_increment,
  uid tinyint(3) unsigned NOT NULL default '0',
  m tinyint(2) NOT NULL default '0',
  d tinyint(2) NOT NULL default '0',
  y smallint(4) NOT NULL default '0',
  start_time time NOT NULL default '00:00:00',
  end_time time NOT NULL default '00:00:00',
  title varchar(50) NOT NULL default '',
  text text NOT NULL,
  PRIMARY KEY  (id),
  KEY id (id),
  KEY m (m),
  KEY y (y),
  KEY uid (uid)
) TYPE=MyISAM;

-- Table structure for table `calendarusers` --

CREATE TABLE calendarusers (
  uid smallint(6) NOT NULL auto_increment,
  username char(15) NOT NULL default '',
  password char(32) NOT NULL default '',
  fname char(20) NOT NULL default '',
  lname char(30) NOT NULL default '0',
  userlevel tinyint(2) NOT NULL default '0',
  email char(40) default NULL,
  PRIMARY KEY  (uid)
) TYPE=MyISAM;

-- Table structure for table `chatlogs` --

CREATE TABLE chatlogs (
  logid int(11) NOT NULL auto_increment,
  logtext text,
  starttime datetime default NULL,
  endtime datetime default NULL,
  inuse int(11) default '1',
  isarchived int(11) default '0',
  PRIMARY KEY  (logid)
) TYPE=MyISAM;

-- Table structure for table `chatuserpreferences` --

CREATE TABLE chatuserpreferences (
  userid int(11) NOT NULL default '0',
  namecolor text,
  fontcolor text,
  dinlist int(11) default '1',
  UNIQUE KEY userid (userid)
) TYPE=MyISAM;

-- Table structure for table `chatusers` --

CREATE TABLE chatusers (
  userid int(11) NOT NULL default '0',
  logintime datetime default NULL,
  lastactive datetime default NULL,
  username text,
  ipaddress text
) TYPE=MyISAM;

-- Table structure for table `courseinformation` --

CREATE TABLE courseinformation (
  email text,
  coursename text,
  mainpage text,
  buttoncolorchoice char(20) default '#000000',
  displaythesebuttons text,
  ofcoursehome char(20) default 'ofcourse.cgi',
  sendmail text,
  ofcourseBGcolor char(20) default '#000000',
  buttonchoice char(20) default 'default',
  buttontextcolor char(20) default '#ffffff'
) TYPE=MyISAM;

-- Table structure for table `cssSettings` --

CREATE TABLE cssSettings (
  bodyBackgroundColor text,
  textColor text,
  linkColor text,
  hoverLinkColor text,
  largerTextColor text,
  discussionBoardPostHeaderColor text,
  newPostBackgroundColor text,
  oldPostBackgroundColor text,
  color1 text,
  color2 text,
  color3 text,
  color4 text,
  color5 text,
  color6 text,
  color7 text,
  color8 text,
  color9 text,
  color10 text
) TYPE=MyISAM;

-- Table structure for table `grades` --

CREATE TABLE grades (
  gid int(11) NOT NULL auto_increment,
  userid int(11) NOT NULL default '0',
  assignid int(11) NOT NULL default '0',
  type text,
  comments text,
  points int(11) NOT NULL default '0',
  points_possible int(11) NOT NULL default '0',
  assignname text,
  isdirty int(11) NOT NULL default '1',	
  PRIMARY KEY  (gid)
) TYPE=MyISAM;

-- Table structure for table `lurker_logins` --

CREATE TABLE lurker_logins (
  loginid int(11) NOT NULL auto_increment,
  username text,
  timeoflogin datetime default NULL,
  loginip text,
  loginhost text,
  success int(11) default NULL,
  PRIMARY KEY  (loginid)
) TYPE=MyISAM;

-- Table structure for table `lurker_logouts` --

CREATE TABLE lurker_logouts (
  logoutid int(11) NOT NULL auto_increment,
  username text,
  timeoflogout datetime default NULL,
  logoutip text,
  logouthost text,
  PRIMARY KEY  (logoutid)
) TYPE=MyISAM;

-- Table structure for table `lurkerchatusers` --

CREATE TABLE lurkerchatusers (
  chatid int(11) NOT NULL auto_increment,
  userid int(11) NOT NULL default '0',
  logintime datetime default NULL,
  logouttime datetime default '0000-00-00 00:00:00',
  ipaddress text,
  PRIMARY KEY  (chatid)
) TYPE=MyISAM;

-- Table structure for table `poll` --

CREATE TABLE poll (
  pollid mediumint(5) unsigned NOT NULL auto_increment,
  topic text,
  question text,
  date varchar(20) default NULL,
  PRIMARY KEY  (pollid)
) TYPE=MyISAM;

-- Table structure for table `users` --

CREATE TABLE users (
  userid int(11) NOT NULL auto_increment,
  firstname text,
  lastname text,
  email text,
  username varchar(10) default NULL,
  password text,
  isadmin int(11) default '0',
  isapproved int(11) default '0',
  checksumid text,
  includeemail int(11) default '1',
  PRIMARY KEY  (userid),
  UNIQUE KEY username (username)
) TYPE=MyISAM;

-- Table structure for table `uservote` --

CREATE TABLE uservote (
  userid int(11) default NULL,
  pollid int(11) default NULL,
  lastname text,
  firstname text,
  email text,
  username text,
  topic text,
  answer text,
  date text
) TYPE=MyISAM;

-- Table structure for table `viewpoll` --

CREATE TABLE viewpoll (
  userid int(11) default NULL,
  firstname text,
  lastname text,
  username text,
  email text,
  times int(11) default NULL,
  lastview text
) TYPE=MyISAM;

-- Table structure for table `vote` --

CREATE TABLE vote (
  pollid int(11) default NULL,
  topic text,
  choice text,
  number int(11) default NULL
) TYPE=MyISAM;

-- data --

DELETE FROM users;	
DELETE FROM courseinformation;
INSERT INTO buttons VALUES (1,'default','Black and White Button');
INSERT INTO buttons VALUES (2,'bluebg.gif','Blue and Green Button');
INSERT INTO courseinformation(ofcoursehome) VALUES('ofcourse.cgi');