#!pathtoperl
use strict;
use CGI::Carp 'fatalsToBrowser';
use CGI;
require "./functions.cgi";



my $query;
$query = new CGI; #get the cgi object

my $isLoggedin = isLoggedin();
my $thread = $query->param("threadid"); #find out which thread we are looking at
my $tptoreturn = $query->param("topicid"); #find out which topic we are looking at
my $threadname;  #store the threadname
my $user; #sore the userid
my $isadmin = isLoggedinAdmin(); #find out if the user is an admin
my %threadhash;  #hash table representing the thread
$user = hasCookie(); #the userid or -1
my $username; 
my $foundfirst = 0;
my $depth=0;
my $timeoflastview; #store the time that the page was last viewd
if($user){ #find out the username if a cookie was found
    $username = getUsername($user);
}
else {
    $username = "";
}

if(!$thread){ #if there was no topic then set topic to -1
    $thread = -1;
}

my $db = connecttodatabase(); #connect to the database
my $approved = isLoggedin(); #find out if the user is logged in
my $topic;

#find out what the thread name is
my $result = $db->query("select * from D_B_Posts where threadid = $thread and isreplyto=0");
if(%threadhash = $result->FetchHash){
    $threadname = $threadhash{threadname};
}

print_html("headers"); #print html headers


#open html 
print '<html><head>'; 

print_html("stylesheet"); #print the stylesheet for the page

my %res = getCourseInfo(); #get the courseinfo and subsequently the course name
my $coursename = $res{coursename};

print "<title>$coursename Discussion Board </title></head></body>"; 
print_html("javascriptvalidation");


if($threadname){ #if the thread was found then print the html
    

    my $replysto = $threadhash{postid}; #all subsequent posts will be replys to this post
    my $hasreplys = hasReplys($thread,$replysto); #check to see if I have any replys
    $topic = $threadhash{topicid}; #get the topic id

    #print a table with the back to links and user information
    print "<table width=100%><tr>";
    print "<td>";
    print "<a href=\"discussion.cgi\">Back to Topic Selection</a><br>";
    print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"threads.cgi?topic=$topic\">Back to Thread Selection</a></td>";
    print "</td>";

    if(!$approved){ 
	print "<td align=right>You are not logged in<br>";
	
	#print a link to the login which will return the user back to here upon successful login
	print "<a href=\"login.cgi?page=posts.cgi?threadid=$thread\">Click here to Login</a></td>";
	$timeoflastview = -1;
    }
    else {
	print "<td align=right>$username logged in </td>";
	
	#need to find out which posts are new.  
	#To do this first find the last time the user viewed the thread
	my $viewresult = $db->query("select timeofview from D_B_Views where userid=$user and threadid=$thread");
	
	if($timeoflastview = $viewresult->FetchRow){
	}
	else {
	    $timeoflastview=-1;
	}
	
	my $foundview = $db->query("select * from D_B_Views where userid=$user and threadid=$thread");
	if(my %hash = $foundview->FetchHash){
	    my $tv = $hash{totalviews};
	    $tv++;
	    $db->query("update D_B_Views set timeofview=now(),totalviews=$tv where viewid=$hash{viewid}");
	}
	else {
	    $db->query("insert into D_B_Views(userid,topicid,threadid,timeofview) values($user,$topic,$thread,now())");
	}
    }
    
    
    print "</tr></table>";
    print '<div align=center>';   
    print "<h1 class=\"bigger\">$threadname</h1>";
    print "<a name=\"topofpage\"></a>";
    print "<br>";
    if($isadmin){ #a note to the instructor about anonymous posts
	print "<br>* User posted anonymously\n";
    }
    print "</div>";
    
    
    printPost($thread,$replysto); #print out the first posts and all posts replying to it.
                                  #the recursive function printPost is defined below    

    #once again print the back to buttons
    print "<table width=100%><tr>";
    print "<td>";
    print "<a href=\"discussion.cgi\">Back to Topic Selection</a><br>";
    print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"threads.cgi?topic=$topic\">Back to Thread Selection</a><br>";
    print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"#topofpage\">Start of this Thread</a></td>";
    print "</td></tr></table>";
    
    

}
else{ #if the threadid was wrong
    print "<div align=center><h1>Invalid Thread ID</h1><br>";
    print "This most likely means the thread you were viewing has been deleted.";
    if($tptoreturn){
	print "<br><a href=\"threads.cgi?topic=$tptoreturn\">Return to Threads</a>";
    }
    else {
	print "<br><a href=\"discussion.cgi\">Return to Topics</a>";
    }
    print "</div>";
    print_html("endhtml");
}



#function takes in the threadid and the first post to display 
#it will then print out the first post, determine if it has any children and
#then make a recursive call with each direct child as the root post
sub printPost{
    $depth++; #keep track of the depth, after 8 stop indenting
    my $thread = shift; #get first parameter
    my $rootpost = shift; #get second parameter
    my $db = connecttodatabase(); 
    
    my $haschildren = hasReplys($thread,$rootpost); #determine if there are any children
    
    
    my $postres=$db->query("select * from D_B_Posts where postid=$rootpost"); #get the post info
    my %post;
    if($depth < 8){print "\n<ul class=\"ouruls\">\n";} #as long as we havent reached depth 8 keep indenting
    if( %post = $postres->FetchHash){
    }
    else {
	print "Thats bad"; #should never reach this point.  
    }
    print "<li>"; #start a new list item
    my $tableat = "border=0 cellspacing=0"; #the attributes on the table containing each post
    if($timeoflastview != -1){ #if the post has been viewed
	my $timediff = $db->query("select unix_timestamp('$timeoflastview') - unix_timestamp(timeofpost) from D_B_Posts where postid=$rootpost"); #find the difference in the times
	my $td = $timediff->FetchRow; 
	if($td < 0){ #if the timedifference is less than 0 than the post is new

	    print "<table class=\"newpost\" $tableat>";
	    
	}
	
	else { #else it is an old post
	    print "<table class=\"oldpost\" $tableat>";
	}
    }
    else { #if the post has never been viewed 
	if($approved){ #approved users see that all posts are new
	    print "<table class=\"newpost\" $tableat>";
	}
	else { #if you arent approved then you see all post as old
	    print "<table class=\"oldpost\" $tableat>";
	}
    }
    
    
    my $postname = cleanPost($post{name}); #parse html in the postname/filter disallowed words
    my $comments = cleanPost($post{posttext}); #parse html in the posttext/filter disallowed words
    print "<tr>";
    
#    my $countchildren=countReplys($rootpost,$thread); #no longer necessary
    print "<th class=\"post\" colspan=3>$postname</th>"; 
    
    
    print "</td>";
    
    print "</tr><tr>";    
    
    print "<td colspan=3 class=\"postcomments\">$comments</td>";
    
    print "</tr><tr>";
    my $timeofpost = $post{timeofpost};
    $timeofpost = parse_time($timeofpost);
    print "<td>$timeofpost</td>";
    
    print "<td align=left>Posted by: ";
    my $poster = getUsername($post{userid});
    my $isanon = $post{isanonymous};
    if($isadmin){
	if($isanon){
	    print   "$poster*";
	}
	else {
	    print "$poster";
	}
    }
    elsif($isanon){
	print "Anonymous";
    }
    else {
	print "$poster";
    }
    
    if($isLoggedin){ #logged in users can reply
	print "<td align=right><a href=\"addnewpost.cgi?replyto=$rootpost&threadid=$thread&topicid=$tptoreturn\">reply to this post&nbsp;</a></td>";
    }
    
    if((isLoggedinAdmin()) && ($post{isreplyto} != 0)){ #admin can delete
	print "</tr><tr>";
	print <<HTML;
	
	<td colspan = 3>
	    <form action="deletepost.cgi" onSubmit="return confirmDelete();" method=post>
	    
	    <input type=hidden name="postid" value="$rootpost">
	    
	    <input type=submit value="Delete this post">
	    
	    </td>
	    
	    </form>
 


HTML

}
	
	
    print "</tr></table></li>\n";
    if($haschildren){ #if there are children 
	my $childres = $db->query("select * from D_B_Posts where threadid=$thread and isreplyto=$rootpost order by timeofpost");
	while(my %childhash = $childres->FetchHash){ #for each child
	    printPost($thread,$childhash{postid}); #recursive call
	    $depth--; #decrease the depth as we move out of the recursion
	}
	if($depth < 8){print "\n</ul>\n";} #when depth is less than 8 print the close unordered list
    }
    else {
	if($depth < 8){print "\n</ul>\n";} 
    }
}



#function counts the total number of replies to a specific post, function is no longer in use
sub countReplys{
    my $rootpost=shift;
    my $thread = shift;
    my $count=0;
    if(hasReplys($thread,$rootpost)){
	my $childres = $db->query("select * from D_B_Posts where threadid=$thread and isreplyto = $rootpost");
	while(my %child=$childres->FetchHash){
	    $count++;
	    $count += countReplys($child{postid},$thread);
	    
	}
	return $count;
    }
    else {
	return 0;
    }
    
}



#function takes in threadid and a postid
#returns true if second parameter has replys, false if it has none
#return value: 1 or 0
sub hasReplys{
    
    my $thread=shift;
    my $replysto=shift;
    
    my $hasreplys = 0;
    my $hrres = $db->query("select * from D_B_Posts where threadid = $thread and isreplyto = $replysto");
    if ($hrres->FetchRow){
	$hasreplys = 1;
    }
    return $hasreplys;

}
